<template>
  <q-page padding>
    <q-overlay v-model="showOverlay">
      <template #body>
        <div class="fullscreen row justify-center items-center">
          <div class="column">
            <q-btn
              no-caps
              outline
              color="deep-purple-13"
              style="background-color: white !important;"
              label="Sign in with Blockstack"
              @click="signInBlockstack"
              icon="img:/statics/images/blockstack.svg"
            ></q-btn>
          </div>
        </div>
      </template>
      <q-calendar
        ref="calendar"
        v-model="date"
        view="month"
        locale="en-us"
        enable-theme
        :theme="$q.dark.isActive ? dark : {}"
        v-touch-swipe.mouse.left.right="handleSwipe"
        animated
        :short-weekday-label="true"
        transition-prev="jump-right"
        transition-next="jump-left"
        @click:day="handleDayClick"
        @click:date="handleDayClick"
        style="overflow: hidden;border: 0px solid grey; cursor: pointer;"
        class="no-background-calendar"
      >
        <template #day="{ date }">
          <q-badge
            multi-line
            color="transparent"
            text-color="grey-1"
            style="width: calc(100vw / 7); height: calc((100vh / 5) - 24px); cursor: pointer;margin-bottom: 8px; overflow: hidden;     word-break: break-word"
            v-if="notes[date]"
            class="q-event fade-out"
            :key="date"
          >{{ dayDisplay(date) }}</q-badge>
        </template>
      </q-calendar>
    </q-overlay>
    <!-- <transition
      appear
      enter-active-class="animated zoomIn"
      leave-active-class="animated zoomOut"
    >-->
    <!-- <q-dialog maximized v-model="editing"> -->
    <q-dialog maximized transition="expand" v-model="editing">
      <q-card fullheight>
        <q-toolbar class="bg-primary text-secondary" reveal="true">
          <q-btn flat round icon="arrow_back" color="grey-1" @click="handleCloseEditor"></q-btn>
          <q-toolbar-title class="grey-1-header">{{ noteTitle }}</q-toolbar-title>
        </q-toolbar>

        <q-card-section>
          <q-input
            type="textarea"
            placeholder="Add some notes to this day..."
            borderless
            v-model="note"
            autogrow
          ></q-input>
        </q-card-section>
      </q-card>
    </q-dialog>
    <!-- </transition> -->
  </q-page>
</template>

<script>
import { userSession } from "boot/blockstack";
import { mapActions, mapState } from "vuex";
import dayjs from "dayjs";

import { authenticate } from "@blockstack/connect";

export default {
  data() {
    return {
      showOverlay: true,
      editing: false,
      empty: "",
      note: "",
      noteTitle: "",
      date: "",
      editorReadOnly: false,
      dragging: false,
      ignoreNextSwipe: false,
      currentCalDisplay: "",
      currentMonth: "",
      dark: {
        name: "dark",
        // body
        colorBody: "grey-2",
        backgroundBody: "blue-grey-8",
        colorBodyOutside: "grey-6",
        backgroundBodyOutside: "blue-grey-9",
        colorBodyPast: "grey-11",
        backgroundBodyPast: "blue-grey-10",
        colorBodyCurrent: "blue-grey-2",
        backgroundBodyCurrent: "blue-grey-10",
        colorBodyFuture: "blue-grey-2",
        backgroundBodyFuture: "blue-grey-10",
        // header - weekly only
        colorHeader: "blue-grey-2",
        backgroundHeader: "blue-grey-10",
        colorHeaderOutside: "blue-grey-2",
        backgroundHeaderOutside: "blue-grey-10",
        // header - for daily only
        colorHeaderPast: "grey-11",
        backgroundHeaderPast: "blue-grey-10",
        colorHeaderCurrent: "blue-grey-2",
        backgroundHeaderCurrent: "blue-grey-10",
        colorHeaderFuture: "blue-grey-2",
        backgroundHeaderFuture: "blue-grey-10",
        // work week - monthly only
        colorWorkWeekPast: "blue-grey-8",
        backgroundWorkWeekPast: "blue-grey-6",
        colorWorkWeekCurrent: "orange-4",
        backgroundWorkWeekCurrent: "blue-grey-10",
        colorWorkWeekFuture: "yellow-4",
        backgroundWorkWeekFuture: "blue-grey-10",
        // label
        colorDayLabelOutside: "blue-grey-2",
        backgroundDayLabelOutside: "blue-grey-9",
        colorDayLabelPast: "yellow-4",
        backgroundDayLabelPast: "blue-grey-10",
        colorDayLabelCurrent: "orange-4",
        backgroundDayLabelCurrent: "blue-grey-10",
        colorDayLabelFuture: "yellow-4",
        backgroundDayLabelFuture: "blue-grey-10",
        // interval body
        colorIntervalHeader: "grey-2",
        backgroundIntervalHeader: "blue-grey-10",
        colorIntervalBody: "grey-2",
        backgroundIntervalBody: "blue-grey-10",
        colorIntervalText: "grey-2",
        backgroundIntervalText: "blue-grey-10",
        // scheduler body
        colorSchedulerHeader: "grey-2",
        backgroundSchedulerHeader: "blue-grey-10",
        colorSchedulerBody: "grey-2",
        backgroundSchedulerBody: "blue-grey-10",
        colorSchedulerText: "grey-2",
        backgroundSchedulerText: "blue-grey-10"
      }
    };
  },
  created() {
    this.$root.$on("navigate", this.handleNavigate);
  },
  beforeDestroy() {
    this.$root.$off("navigate", this.handleNavigate);
  },
  beforeMount() {
    const now = new Date();
    this.date =
      now.getFullYear() +
      "-" +
      this.padNumber(now.getMonth() + 1, 2) +
      "-" +
      this.padNumber(now.getDay(), 2);
  },
  mounted() {
    if (userSession.isUserSignedIn()) {
      this.showOverlay = false;
    } else {
      this.showOverlay = true;
    }
  },
  computed: {
    ...mapState(["notes", "user"])
  },
  methods: {
    ...mapActions([
      "addDay",
      "updateDay",
      "deleteDay",
      "setUser",
      "setNotes",
      "loadBlockstackData",
      "initBlockstack"
    ]),
    signInBlockstack() {
      const authOptions = {
        appDetails: {
          name: "Hoverlook",
          icon: "https://hoverlook.app/statics/icons/icon-256x256.png"
        },
        finished: async () => {
          this.initBlockstack();
          this.showOverlay = false;
        }
      };
      authenticate(authOptions);
    },

    async handleNavigate(direction) {
      if (direction === "prev") {
        await this.$refs.calendar.prev();
        this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
      } else if (direction === "next") {
        await this.$refs.calendar.next();
        this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
      } else {
        this.date = new Date().toISOString().slice(0, 10);
        this.$nextTick(() => {
          this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
        });
      }
    },
    async calendarNext() {
      await this.$refs.calendar.next();
      this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
    },
    async calendarPrev() {
      await this.$refs.calendar.prev();
      this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
    },
    dayDisplay(selectedDate) {
      const words = this.notes[selectedDate]
        .split(/\s+/) // *do you know how to respect line breaks? I don't care about any other formatting, but it would be nice to retain the line breaks...
        // .slice(0, 13) *removed limit
        .join(" ");
      return words;
    },
    handleSwipe({ evt, ...info }) {
      if (this.dragging === false) {
        if (info.duration >= 30 && this.ignoreNextSwipe === false) {
          if (info.direction === "right") {
            this.calendarPrev();
          } else if (info.direction === "left") {
            this.calendarNext();
          }
        } else {
          this.ignoreNextSwipe = false;
        }
      }
      // stopAndPrevent(evt)
      evt.cancelable !== false && evt.preventDefault();
      evt.stopPropagation();
    },
    handleDayClick(e) {
      this.date = e.date;
      if (this.notes[this.date]) {
        // we have an existing note
        this.note = this.notes[this.date];
        this.editorReadOnly = true;
      }
      this.noteTitle = dayjs(e.date).format("ddd, MMMM D");
      this.editing = true;
    },
    async handleCloseEditor() {
      if (this.note.length) {
        await this.addDay({ id: this.date, note: this.note });
      }
      this.editing = false;
      this.noteTitle = "";
      this.note = "";
      this.editorReadOnly = false;
      await this.$refs.calendar.date;
      this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
    },
    padNumber(num, length) {
      let padded = String(num);
      while (padded.length < length) {
        padded = "0" + padded;
      }
      return padded;
    }
  },
  beforeRouteLeave(to, from, next) {
    // called when the route that renders this component is about to
    // be navigated away from.
    // has access to `this` component instance.
    if (this.editing) {
      this.editing = false;
      next(false);
    } else {
      next();
    }
  }
};
</script>
<style scoped>
/* always present */
.expand-transition {
  transition: all 0.3s ease;
  height: 30px;
  padding: 10px;
  background-color: #eee;
  overflow: hidden;
}
/* .expand-enter defines the starting state for entering */
/* .expand-leave defines the ending state for leaving */
.expand-enter,
.expand-leave {
  height: 0;
  padding: 0 10px;
  opacity: 0;
}
</style>
